﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using Infragistics.Win;
using Infragistics.Win.UltraWinTabControl;
using Infragistics.Win.UltraWinTabs;

namespace WindowsFormsApplication32
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            ultraTabControl1.CreationFilter = new CF();
        }

        private void ultraButton1_Click(object sender, EventArgs e)
        {
            ultraTabControl1.SelectedTab = ultraTabControl1.Tabs[ultraTabControl1.SelectedTab.Index - 1];
        }

        private void ultraButton2_Click(object sender, EventArgs e)
        {
            ultraTabControl1.SelectedTab = ultraTabControl1.Tabs[ultraTabControl1.SelectedTab.Index + 1];
        }
    }

    class CF : IUIElementCreationFilter
    {
        public void AfterCreateChildElements(UIElement parent) { }

        public bool BeforeCreateChildElements(UIElement parent)
        {
            if (parent is TabHeaderAreaUIElement)
            {
                TabHeaderAreaUIElement headerArea = parent as TabHeaderAreaUIElement;
                TabLineUIElement line = new TabLineUIElement(parent, headerArea.TabManager);
                Rectangle rect = new Rectangle(headerArea.Rect.X, headerArea.Rect.Y + headerArea.Rect.Height - 2, headerArea.Rect.Width, 2);
                line.Rect = rect;
                headerArea.ChildElements.Add(line);
                TextUIElement text = new TextUIElement(parent, headerArea.TabManager.SelectedTabItem.Text);
                text.Rect = parent.Rect;

                if (((TextUIElement)parent.GetDescendant(typeof(TextUIElement))) != null)
                {
                    parent.ChildElements.Remove(((TextUIElement)parent.GetDescendant(typeof(TextUIElement))));
                    text.Text = headerArea.TabManager.SelectedTabItem.Text;
                    parent.ChildElements.Add(text);
                }
                else parent.ChildElements.Add(text);
                return true;
            }
            else
            {
                return false;
            }
        }
    }

}
